//+------------------------------------------------------------------+
//|                                              NonLagDotSignal.mqh |
//|                             Copyright  2011,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
#property tester_indicator "NonLagDot.ex5"
#include <Expert\ExpertSignal.mqh>
//--- wizard description start
//+------------------------------------------------------------------+ 
//|                                                |
//+------------------------------------------------------------------+ 
#define OPEN_LONG     80  //          
#define OPEN_SHORT    80  //          
#define CLOSE_LONG    40  //          
#define CLOSE_SHORT   40  //          
#define REVERSE_LONG  100 //         
#define REVERSE_SHORT 100 //         
#define NO_SIGNAL      0  //         
//+------------------------------------------------------------------+
//| Description of the class                                         |
//| Title=,    NonLagDot                |
//| Type=SignalAdvanced                                              |
//| Name=NonLagDot                                                   |
//| Class=CNonLagDotSignal                                           |
//| Page=                                                            |
//| Parameter=BuyPosOpen,bool,true,           |
//| Parameter=SellPosOpen,bool,true,          |
//| Parameter=BuyPosClose,bool,true,      |
//| Parameter=SellPosClose,bool,true,     |
//| Parameter=Ind_Timeframe,ENUM_TIMEFRAMES,PERIOD_H4,      |
//| Parameter=Price,ENUM_APPLIED_PRICE,PRICE_CLOSE,  |
//| Parameter=Type,ENUM_MA_METHOD,MODE_SMA,           |
//| Parameter=Length,uint,10,                 |
//| Parameter=Filter,uint,0,                                   |
//| Parameter=Swing,double,0,                              |
//| Parameter=SignalBar,uint,1,              |
//+------------------------------------------------------------------+
//--- wizard description end
//+------------------------------------------------------------------+
//|  CNonLagDotSignal.                                          |
//| :            |
//|  NonLagDot http://www.mql5.com/ru/code/694/.           |
//|     CExpertSignal.                    |
//+------------------------------------------------------------------+
class CNonLagDotSignal : public CExpertSignal
  {
protected:
   CiCustom          m_indicator;        //      NonLagDot

   //---  
   bool              m_BuyPosOpen;       //     
   bool              m_SellPosOpen;      //     
   bool              m_BuyPosClose;      //     
   bool              m_SellPosClose;     //     
   ENUM_TIMEFRAMES   m_Ind_Timeframe;    //   NonLagDot
   ENUM_APPLIED_PRICE m_Price;           //  
   ENUM_MA_METHOD    m_Type;             //  
   uint              m_Length;           //   
   uint              m_Filter;           // 
   double            m_Swing;            //    
   uint              m_SignalBar;        //      

public:
                     CNonLagDotSignal();

   //---    
   void              BuyPosOpen(bool value)                  { m_BuyPosOpen=value;       }
   void              SellPosOpen(bool value)                 { m_SellPosOpen=value;      }
   void              BuyPosClose(bool value)                 { m_BuyPosClose=value;      }
   void              SellPosClose(bool value)                { m_SellPosClose=value;     }
   void              Ind_Timeframe(ENUM_TIMEFRAMES value)    { m_Ind_Timeframe=value;    }
   void              Price(ENUM_APPLIED_PRICE value)         { m_Price=value;            }
   void              Type(ENUM_MA_METHOD value)              { m_Type=value;             }
   void              Length(uint value)                      { m_Length=value;           }
   void              Filter(uint value)                      { m_Filter=value;           }
   void              Swing(double value)                     { m_Swing=value;            }
   void              SignalBar(uint value)                   { m_SignalBar=value;        }

   //---    
   virtual bool      ValidationSettings();
   //---    
   virtual bool      InitIndicators(CIndicators *indicators); //  
   //---      
   virtual int       LongCondition();
   virtual int       ShortCondition();

   bool              InitNonLagDot(CIndicators *indicators);  // ,   NonLagDot
  };
//+------------------------------------------------------------------+
//|  CNonLagDotSignal.                                    |
//| INPUT:  .                                                     |
//| OUTPUT: .                                                     |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
void CNonLagDotSignal::CNonLagDotSignal()
  {
//---    
   m_BuyPosOpen=true;
   m_SellPosOpen=true;
   m_BuyPosClose=true;
   m_SellPosClose=true;

//---   
   m_Ind_Timeframe=PERIOD_H4;
   m_Price=PRICE_CLOSE;
   m_Type=MODE_SMA;
   m_Length=10;
   m_Filter=0;
   m_Swing=0;
//---  
   m_SignalBar=1;
   m_used_series=USE_SERIES_OPEN+USE_SERIES_HIGH+USE_SERIES_LOW+USE_SERIES_CLOSE;
  }
//+------------------------------------------------------------------+
//|   .                                   |
//| INPUT:  .                                                     |
//| OUTPUT: true -   ,  false.           |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
bool CNonLagDotSignal::ValidationSettings()
  {
//---  
   if(m_Length<=0)
     {
      printf(__FUNCTION__+":       ");
      return(false);
     }

//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|    .                           |
//| INPUT:  indicators -   -               |
//|                        .                    |
//| OUTPUT: true -    ,  false.       |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
bool CNonLagDotSignal::InitIndicators(CIndicators *indicators)
  {
//---  
   if(indicators==NULL) return(false);

//---  
   if(!InitNonLagDot(indicators)) return(false);

//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   NonLagDot.                              |
//| INPUT:  indicators -   -               |
//|                        .                    |
//| OUTPUT: true -    ,  false.       |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
bool CNonLagDotSignal::InitNonLagDot(CIndicators *indicators)
  {
//---  
   if(indicators==NULL) return(false);

//---    
   if(!indicators.Add(GetPointer(m_indicator)))
     {
      printf(__FUNCTION__+":   ");
      return(false);
     }

//---   
   MqlParam parameters[6];
   
   parameters[0].type=TYPE_STRING;
   parameters[0].string_value="NonLagDot.ex5";
   
   parameters[1].type=TYPE_UINT;
   parameters[1].integer_value=m_Price;
   
   parameters[2].type=TYPE_UINT;
   parameters[2].integer_value=m_Type;
   
   parameters[3].type=TYPE_UINT;
   parameters[3].integer_value=m_Length;
   
   parameters[4].type=TYPE_UINT;
   parameters[4].integer_value=m_Filter;
   
   parameters[5].type=TYPE_DOUBLE;
   parameters[5].double_value=m_Swing;

//---     
   if(!m_indicator.Create(m_symbol.Name(),m_Ind_Timeframe,IND_CUSTOM,6,parameters))
     {
      printf(__FUNCTION__+":   ");
      return(false);
     }
     
//---  
   if(!m_indicator.NumBuffers(2)) return(false);
   
//---     NonLagDot
   return(true);
  }
//+------------------------------------------------------------------+
//|                              |
//|                            |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CNonLagDotSignal::LongCondition()
  {
//---       1  NonLagDot
   double Signal0=m_indicator.GetData(1,m_SignalBar);
   double Signal1=m_indicator.GetData(1,m_SignalBar+1);

//---    
   if(Signal0==2)
     {
      if(Signal1==1)
        {

         if(m_BuyPosOpen)
           {
            if(m_SellPosClose) return(REVERSE_SHORT);
            else return(OPEN_LONG);
           }

         if(m_SellPosClose) return(CLOSE_SHORT);
        }
     }
//---   
   return(NO_SIGNAL);
  }
//+------------------------------------------------------------------+
//|                              |
//|                            |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CNonLagDotSignal::ShortCondition()
  {
//---       1  NonLagDot
   double Signal0=m_indicator.GetData(1,m_SignalBar);
   double Signal1=m_indicator.GetData(1,m_SignalBar+1);

//---    
   if(Signal0==1)
     {
      if(Signal1==2)
        {

         if(m_SellPosOpen)
           {
            if(m_BuyPosClose) return(REVERSE_LONG);
            else return(OPEN_SHORT);
           }

         if(m_BuyPosClose) return(CLOSE_LONG);
        }
     }
//---      
   return(NO_SIGNAL);
  }
//+------------------------------------------------------------------+
